'Restores Windows 10 TaskMgr.exe (and related files) to Windows 11.
'Tested in Windows 11 22H2.
'Written by Ramesh Srinivasan for Winhelponline.com

Option Explicit

If WScript.Arguments.length = 0 Then
   Dim objShell: Set objShell = CreateObject("Shell.Application")
   objShell.ShellExecute "wscript.exe", Chr(34) & _
   WScript.ScriptFullName & Chr(34) & " uac", "", "runas", 1
Else
   Dim WshShell: Set WshShell = CreateObject("WScript.Shell")
   Dim FSO: Set FSO = CreateObject ("Scripting.FileSystemObject")
   Dim sCurrDir, sProgDir, sErr, sReg, sOut, fldr
   sCurrDir = FSO.GetParentFolderName(WScript.ScriptFullName)
   sProgDir = WshShell.ExpandEnvironmentStrings("%PROGRAMFILES%")
   sProgDir = sProgDir & "\Classic Apps\Task Manager"
   
   CreateFldr sProgDir & "\SystemResources"
   CreateFldr sProgDir & "\Program\en-US"
   sReg = "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\" & _
   "Image File Execution Options\taskmgr.exe\Debugger"
   
   Dim arrSrc, arrDest, file, ErrFlags, i
   ErrFlags = 0
   
   arrSrc = Array ( _
   sCurrDir & "\Taskmgr.exe", _
   sCurrDir & "\Taskmgr.exe.mui", _
   sCurrDir & "\Taskmgr.exe.mun" _
   )
   
   arrDest = Array ( _
   sProgDir & "\Program\Taskmgr2.exe", _
   sProgDir & "\Program\en-US\Taskmgr2.exe.mui", _   
   sProgDir & "\SystemResources\Taskmgr2.exe.mun" _
   )
   
   'Check if source files exist
   For Each file In arrSrc
      If Not FSO.FileExists (file) Then
         WScript.Echo "Task Manager files are missing from the script folder."
         WScript.Quit
      End If
   Next
   
   'Copy Taskmgr.* as Taskmgr2.* under "Program Files"
   For i = 0 To UBound(arrDest)
      On Error Resume Next
      FSO.CopyFile arrSrc(i), arrDest(i), True
      If err.number <> 0 Then
         ErrFlags = 1
         sErr = sErr & err.number & " - " & err.Description & _
         " when copying file " & arrDest(i) & vbCrLf
      End If
      On Error GoTo 0
   Next
   
   'Replace Taskmgr.exe using IFEO registry key
   If ErrFlags = 0 Then
      On Error Resume Next
      WshShell.RegWrite sReg, """" & arrDest(0) & """", "REG_SZ"
      sErr = Err.number
      On Error GoTo 0
      
      If sErr = 0 Then
         WScript.Echo "SUCCESS. Task Manager has been replaced with an older version."
      Else
         sOut = "An error occurred when writing to the registry." & vbCrLf & _
         "Error: " & err.number & " - " & err.Description & vbCrLf & vbCrLf & _
         "Please delete Taskmgr2.exe, Taskmgr2.exe.mui, and Taskmgr2.exe.mun manually."
         WScript.Echo sOut
      End If
   Else
      sOut = "An error occurred when copying a file." & vbCrLf & _
      "Error: " & sErr & vbCrLf & vbCrLf & _
      "Please delete Taskmgr2.exe, Taskmgr2.exe.mui, and Taskmgr2.exe.mun manually."
      WScript.Echo sOut
      WScript.Quit
   End If
End If

Sub CreateFldr (fldr)
   If Not FSO.FolderExists(fldr) Then
      CreateFldr FSO.GetParentFolderName(fldr)
      FSO.CreateFolder fldr
   End If
End Sub